X-Git-Url: https://git.rohieb.name/openwrt.git/blobdiff_plain/d110b89b7be2bcc140ecece3e855a288dd4cdfc0..77ec3b2de9bb1880b258ec6aaf4949f146f6fd8d:/package/base-files/files/lib/upgrade/common.sh

diff --git a/package/base-files/files/lib/upgrade/common.sh b/package/base-files/files/lib/upgrade/common.sh
index 7584b773d..e97958bf9 100644
--- a/package/base-files/files/lib/upgrade/common.sh
+++ b/package/base-files/files/lib/upgrade/common.sh
@@ -21,6 +21,9 @@ install_bin() { # <file> [ <symlink> ... ]
 	files=$1
 	[ -x "$src" ] && files="$src $(libs $src)"
 	install_file $files
+	[ -e /lib/ld-linux.so.3 ] && {
+		install_file /lib/ld-linux.so.3
+	}
 	shift
 	for link in "$@"; do {
 		dest="$RAM_ROOT/$link"
@@ -32,7 +35,7 @@ install_bin() { # <file> [ <symlink> ... ]
 
 pivot() { # <new_root> <old_root>
 	mount | grep "on $1 type" 2>&- 1>&- || mount -o bind $1 $1
-	mkdir -p $1$2 $1/proc $1/dev $1/tmp $1/jffs && \
+	mkdir -p $1$2 $1/proc $1/dev $1/tmp $1/overlay && \
 	mount -o move /proc $1/proc && \
 	pivot_root $1 $1$2 || {
         umount $1 $1
@@ -40,12 +43,17 @@ pivot() { # <new_root> <old_root>
 	}
 	mount -o move $2/dev /dev
 	mount -o move $2/tmp /tmp
-	mount -o move $2/jffs /jffs 2>&-
+	mount -o move $2/overlay /overlay 2>&-
 	return 0
 }
 
 run_ramfs() { # <command> [...]
-	install_bin /bin/busybox /bin/ash /bin/sh /bin/mount /bin/umount /sbin/pivot_root /usr/bin/wget /sbin/reboot /bin/sync /bin/dd /bin/grep /bin/cp /bin/mv /bin/tar /usr/bin/md5sum "/usr/bin/[" /bin/vi /bin/ls /bin/cat
+	install_bin /bin/busybox /bin/ash /bin/sh /bin/mount /bin/umount        \
+		/sbin/pivot_root /usr/bin/wget /sbin/reboot /bin/sync /bin/dd   \
+		/bin/grep /bin/cp /bin/mv /bin/tar /usr/bin/md5sum "/usr/bin/[" \
+		/bin/vi /bin/ls /bin/cat /usr/bin/awk /usr/bin/hexdump          \
+		/bin/sleep /bin/zcat /usr/bin/bzcat /usr/bin/printf /usr/bin/wc
+
 	install_bin /sbin/mtd
 	for file in $RAMFS_COPY_BIN; do
 		install_bin $file
@@ -60,15 +68,47 @@ run_ramfs() { # <command> [...]
 	mount -o remount,ro /mnt
 	umount -l /mnt
 
-	grep /jffs /proc/mounts > /dev/null && {
-		mount -o remount,ro /jffs
-		umount -l /jffs
+	grep /overlay /proc/mounts > /dev/null && {
+		mount -o remount,ro /overlay
+		umount -l /overlay
 	}
 
 	# spawn a new shell from ramdisk to reduce the probability of cache issues
 	exec /bin/busybox ash -c "$*"
 }
 
+kill_remaining() { # [ <signal> ]
+	local sig="${1:-TERM}"
+	echo -n "Sending $sig to remaining processes ... "
+
+	local stat
+	for stat in /proc/[0-9]*/stat; do
+		local pid name state ppid rest
+		read pid name state ppid rest < $stat
+		name="${name#(}"; name="${name%)}"
+
+		local cmdline
+		read cmdline < /proc/$pid/cmdline
+
+		# Skip kernel threads 
+		[ -n "$cmdline" ] || continue
+
+		case "$name" in
+			# Skip essential services
+			*ash*|*init*|*watchdog*|*ssh*|*dropbear*|*telnet*|*login*|*ubusd*|*netifd*|*hostapd*|*wpa_supplicant*|*udhcpc*) : ;;
+
+			# Killable process
+			*)
+				if [ $pid -ne $$ ] && [ $ppid -ne $$ ]; then
+					echo -n "$name "
+					kill -$sig $pid 2>/dev/null
+				fi
+			;;
+		esac
+	done
+	echo ""
+}
+
 run_hooks() {
 	local arg="$1"; shift
 	for func in "$@"; do
@@ -103,17 +143,32 @@ rootfs_type() {
 	mount | awk '($3 ~ /^\/$/) && ($5 !~ /rootfs/) { print $5 }'
 }
 
-get_image() {
+get_image() { # <source> [ <command> ]
 	local from="$1"
+	local conc="$2"
+	local cmd
 
 	case "$from" in
-		http://*|ftp://*) wget -O- -q "$from";;
-		*) cat "$from"
+		http://*|ftp://*) cmd="wget -O- -q";;
+		*) cmd="cat";;
 	esac
+	if [ -z "$conc" ]; then
+		local magic="$(eval $cmd $from | dd bs=2 count=1 2>/dev/null | hexdump -n 2 -e '1/1 "%02x"')"
+		case "$magic" in
+			1f8b) conc="zcat";;
+			425a) conc="bzcat";;
+		esac
+	fi
+
+	eval "$cmd $from ${conc:+| $conc}"
 }
 
 get_magic_word() {
-	get_image "$1" | dd bs=2 count=1 2>/dev/null | hexdump | awk '$2 { print $2 }'
+	get_image "$@" | dd bs=2 count=1 2>/dev/null | hexdump -v -n 2 -e '1/1 "%02x"'
+}
+
+get_magic_long() {
+	get_image "$@" | dd bs=4 count=1 2>/dev/null | hexdump -v -n 4 -e '1/1 "%02x"'
 }
 
 refresh_mtd_partitions() {
@@ -130,11 +185,24 @@ jffs2_copy_config() {
 	fi
 }
 
+default_do_upgrade() {
+	sync
+	if [ "$SAVE_CONFIG" -eq 1 -a -z "$USE_REFRESH" ]; then
+		get_image "$1" | mtd -j "$CONF_TAR" write - "${PART_NAME:-image}"
+	else
+		get_image "$1" | mtd write - "${PART_NAME:-image}"
+	fi
+}
+
 do_upgrade() {
 	v "Performing system upgrade..."
-	platform_do_upgrade "$ARGV"
-	
-	[ "$SAVE_CONFIG" -eq 1 ] && {
+	if type 'platform_do_upgrade' >/dev/null 2>/dev/null; then
+		platform_do_upgrade "$ARGV"
+	else
+		default_do_upgrade "$ARGV"
+	fi
+
+	[ "$SAVE_CONFIG" -eq 1 -a -n "$USE_REFRESH" ] && {
 		v "Refreshing partitions"
 		if type 'platform_refresh_partitions' >/dev/null 2>/dev/null; then
 			platform_refresh_partitions
@@ -147,5 +215,12 @@ do_upgrade() {
 			jffs2_copy_config
 		fi
 	}
-	ask_bool 1 "Reboot" && reboot
+	v "Upgrade completed"
+	[ -n "$DELAY" ] && sleep "$DELAY"
+	ask_bool 1 "Reboot" && {
+		v "Rebooting system..."
+		reboot -f
+		sleep 5
+		echo b 2>/dev/null >/proc/sysrq-trigger
+	}
 }